from ast import literal_eval
from copy import copy
from typing import Union

import yaml

from evaluation.eval_settings import EvaluationSettings
from utils.gs2dict import generate_variants


def t1():
    evaluation_config = EvaluationSettings().dict()

    evaluation_config['name'] = {"grid_search": [1, 2, 3, 4]}
    evaluation_config['q'] = {"lambda spec": 'random.uniform(1, 100)'}
    for resolved_vars, eval_config in generate_variants(evaluation_config, ):
        print(resolved_vars, eval_config)


def check_nested_grid_searches(source):
    if isinstance(source, dict):
        for key, value in source.items():
            if key == 'grid_search' or check_nested_grid_searches(value):
                return True

    if isinstance(source, list):
        for value in source:
            if check_nested_grid_searches(value):
                return True

    return False


def split_backbone(source: Union[dict, list], backbone: dict = None, mutable: list = None, path=None):
    if backbone is None:
        backbone = {}
    if mutable is None:
        mutable = []
    if path is None:
        path = []

    if isinstance(source, dict):
        for key, value in source.items():
            if key == 'grid_search':
                mutable.append([copy(path), value])
                if check_nested_grid_searches(value):
                    raise KeyError('Nested grid searches is not supported!')
                continue
            if isinstance(value, dict):
                path.append(key)
                backbone[key] = split_backbone(source=value, backbone=backbone, mutable=mutable, path=path)
                path.pop()
            else:
                backbone[key] = value
    elif isinstance(source, list):
        pass
    else:
        raise KeyError('Unknown source.')
    return backbone, mutable


def dd_nested_grid_search():
    split_backbone({"tt": {"grid_search": [{1: 2}, {2: 2}, {3: 3}, {4: 4}, {'grid_search': [1, 2, 3]}]}})


def main():
    with open('../configs/eval.yaml', "r") as f:
        evaluation_config = yaml.safe_load(f)
    # evaluation_config = EvaluationSettings().dict()
    # dd_nested_grid_search()
    split_backbone(evaluation_config)
    # testing nested grid search
    # evaluation_config =
    print(evaluation_config)
    print(split_backbone(evaluation_config)[1])


if __name__ == '__main__':
    main()
